use strict;
use warnings;
use utf8;
use DBI;

########## パラメータ ##########

# DB、ユーザＩＤ、パスワード
my ( $db, $usr, $pass ) = ('DBI:mysql:database=item2;host=localhost', '**user**', '**pass**');

# バックアップへのパス
my $bkSite = "/var/www/*****/gpmanager/mirror_site";

########## パラメータ ##########


# itemを取得
my ($dbh, $query, $sth) = ();
$dbh = DBI->connect('DBI:mysql:database=item2;host=localhost', 'root', 'yorokonde4649') or die "cannnot connect item";
$query = "select item_id, item_URL from tbl_item;";
$sth = $dbh->prepare($query);
$sth->execute() or die "cannnot exe";
my $row = $sth->rows;

my @items = ();

while ( $row > 0 ) {

	my @hit = $sth->fetchrow_array;
	my $item_info = { 'id'=>$hit[0], 'url'=>$hit[1] };
	push ( @items, $item_info );
	$row--;

}

# /var/www/*****/gpmanager/mirror_site
my $mir_dir = $bkSite;

# アイテムの数だけ繰り返す
foreach my $item ( @items ) {

	# アイテムのＩＤとＵＲＬ
	my $id  = $item->{'id'};
	my $url = $item->{'url'};
	$url =~ s/http:\/\///;	    

	my $item_dir = "$mir_dir"."/"."$id";
	unless ( opendir ( ITEM, $item_dir ) ) {
		print "[Error] cannnot open $item_dir";
		next;
	} 
	my @date_dir = readdir ITEM;

	# 日付フォルダの数だけ繰り返す
	foreach my $date_dir ( @date_dir ) {

		my $date_dir_path = $item_dir."/".$date_dir;

	       
		if ( -d $date_dir_path and $date_dir =~ /\d\d\d\d-\d\d-\d\d_\d\d-\d\d-\d\d/ ) {

			# アイテムへのパスを特定する処理

			# ３パターンのパスを定義
			my $base_path = $item_dir."/".$date_dir."/".$url;	# オリジナルのＵＲＬ
			my $html_path = $base_path.".html";
			$base_path =~ /(^.+)(\#.*$)/;
			my $truncated_path = $1;
			my $index_path = $base_path."index.html";
#			my $index_path2 = $base_path."/index.html";

			$base_path = '' unless ( defined($base_path) );
			$html_path = '' unless ( defined($html_path) );
			$truncated_path = '' unless ( defined($truncated_path) );

			# ファイルが存在するか検証
			my $exist_flag = 0;
			my $abs_path = ();
			my $delete = $item_dir."/".$date_dir."/";

			if ( -f $base_path ) {
				$abs_path = $base_path;
				$abs_path =~ s/$date_dir_path\///;
				$exist_flag++;
			}

			if ( -f $html_path ) {
				$abs_path = $html_path;
				$abs_path =~ s/$date_dir_path\///;
				$exist_flag++;
			}

			if ( -f $truncated_path ) {
				$abs_path = $truncated_path;
				$abs_path =~ s/$date_dir_path\///;
				$exist_flag++;
			}

			if ( -f $index_path ) {
				$abs_path = $index_path;
				$abs_path =~ s/$date_dir_path\///;
				$exist_flag++;
			}

=pod
			if ( -f $index_path2 ) {
				$abs_path = $index_path2;
				$abs_path =~ s/$date_dir_path//;
				$exist_flag++;
			}
=cut


			if ( $exist_flag == 1 ) {

				# link.txtを出力
				my $link_txt = $item_dir."/".$date_dir."/"."link.txt";
				

				if ( ! -f $link_txt) {	# 素手にファイルがある場合は処理なし

					if ( open (LINK, ">>$link_txt") ) {
						# ?を%3fに変換
						$abs_path =~ s/\?/\%3f/g;

						print LINK "1\t$abs_path";
						close(LINK);
					} else {
						print "[Error]cannnot open $link_txt\n";
					}
				}


			} else {
				print "[Error] $base_path\t$exist_flag\n";
			}

		}

	}

}
